#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "common1.h"
#include "common2.h"
#include "common3.h"

  void write_table();
  void write_table1();
  void write_table2();
  void write_cap();

int main()
{ FILE *fp;
  int i,j,k,n;

  char fn[13];

  init_param();
  read_file();
  init_num();

  x=m_darr2(LR,JC);
  g=m_darr2(LR,JC);
  sd=m_darr2(LR,IR);
  p=m_darr1(KE);

  ts_trade=m_iarr1(IINTER+ITRANS);
  ts_exha=m_iarr1(N_FOS);
  ts_ene=m_iarr1(9);
  ts_wep=m_iarr1(N_FOS+N_REN+1);
  ts_wco=m_iarr1(5);
  ts_ies=m_iarr1(3);
  ts_bio=m_iarr1(7);
  td_ndemd=m_iarr1(5);
  td_edemd=m_iarr1(6);
  tp_elec=m_iarr1(9);
  tp_chem=m_iarr1(19);
  tc_price=m_iarr1(8);
  tc_cost=m_iarr1(18);
  id_cost=m_iarr1(18);

  JT=0;
  for(i=0;i<IINTER+ITRANS;i++) ts_trade[i]=JT++;
  for(i=0;i<9;i++) ts_ene[i]=JT++;
  for(i=0;i<N_FOS+N_REN+1;i++) ts_wep[i]=JT++;
  for(i=0;i<5;i++) ts_wco[i]=JT++;
  for(i=0;i<3;i++) ts_ies[i]=JT++;
  ts_rco2=JT++;
  for(i=0;i<5;i++) td_ndemd[i]=JT++;
  for(i=0;i<6;i++) td_edemd[i]=JT++;
  for(i=0;i<9;i++) tp_elec[i]=JT++;
  for(i=0;i<19;i++) tp_chem[i]=JT++;
  for(i=0;i<8;i++) tc_price[i]=JT++;
  for(i=0;i<18;i++) tc_cost[i]=JT++;
  ta_eco2=JT++;
  for(i=0;i<N_FOS;i++) ts_exha[i]=JT++;
  for(i=0;i<7;i++) ts_bio[i]=JT++;
  ts_dco2=JT++;
  ts_pene=JT++;
  ts_psup=JT++;
  ts_sene=JT++;
  ts_cco2=JT++;
  ts_cont=JT++;

  tx=m_darr4(LR+6,JT,30,N_BLK);
  for(n=0;n<LR+6;n++)
    for(j=0;j<JT;j++)
      for(i=0;i<30;i++)
        for(k=0;k<N_BLK;k++)
          tx[n][j][i][k]=0.;
  agg=m_darr2(LR,N_BLK);

  read_result();
  init_report();

  climate(0,co2emi,tsoxemi);

  for(n=0;n<LR;n++) {
    account_r(n,tx[n],x[n]);
    account_c(n,tx[n],x[n],sd[n]);
  }

  account_w();
  account_m();

  fn[0]='r';fn[1]='e';fn[2]='g';fn[3]='i';fn[4]='o';fn[5]='n';
  for(n=0;n<LR;n++) {
    if(1+n>9) {
      fn[6]='1';fn[7]='0'+n-9;fn[8]='.';fn[9]='r';
      fn[10]='e';fn[11]='p';fn[12]='\0';
    }
    else {
      fn[6]='1'+n;fn[7]='.';fn[8]='r';fn[9]='e';fn[10]='p';fn[11]='\0';
    }
    fp=fopen(fn,"w");
    title(fp,n);
    report_r(fp,n,tx[n]);
    fclose(fp);
  }

  fp=fopen("world.rep","w");
  title(fp,LR);
  report_r(fp,LR,tx[LR]);
  fclose(fp);

  fp=fopen("oecd.rep","w");
  title(fp,LR+1);
  report_r(fp,LR+1,tx[LR+1]);
  fclose(fp);

  fp=fopen("n_oecd.rep","w");
  title(fp,LR+2);
  report_r(fp,LR+2,tx[LR+2]);
  fclose(fp);

  fp=fopen("annex1.rep","w");
  title(fp,LR+3);
  report_r(fp,LR+3,tx[LR+3]);
  fclose(fp);

  fp=fopen("n_annex1.rep","w");
  title(fp,LR+4);
  report_r(fp,LR+4,tx[LR+4]);
  fclose(fp);

  fp=fopen("asian.rep","w");
  title(fp,LR+5);
  report_r(fp,LR+5,tx[LR+5]);
  fclose(fp);

  report_e();

  return;
}




  void init_report()
{ int i,j;
  isce=m_iarr2(N_SCE,N_TMP);
  for(i=0;i<N_SCE;i++)
    for(j=0;j<N_BLK;j++)
      if(n_sc[i][j]==1)
        isce[i][n_tm[j]]=j;
}

  void report_r(fp,n,txm)
  FILE *fp;
  int n;
  double ***txm;
{ int nc;
  char *cap,*str[30];

  nc=1;

  cap="Contribution to the reduction of CO2 emissions (Mt-C/year)";
  str[0]="Demand Increase";
  str[1]="  Conservation ";
  str[2]="   Conversion  ";
  str[3]="  Fuel Switch  ";
  str[4]=" CO2  Disposal ";
  str[5]="  Net Emission ";
  write_table(fp,&nc,cap,str,txm[ts_cont],6,N_TMP);
  fprintf(fp,"----------------------------\n");
  fprintf(fp," Emission in 2000 : %8.1f\n",cem_2000[n]);

  cap="Primary Energy Production (MTOE/year)";
  str[0]="  Natural Gas  ";
  str[1]="   Crude Oil   ";
  str[2]="     Coal      ";
  str[3]=" Hydro & Geoth.";
  str[4]="     Wind      ";
  str[5]=" Photovoltaics ";

  str[6]="    Biomass    ";
  str[7]="    Nuclear    ";
  str[8]="  Innovatives  ";
  write_table(fp,&nc,cap,str,txm[ts_pene],9,N_TMP);

  if(n!=LR) {
    cap="Regional Energy Supply (MTOE/year)";
    str[0]="  Natural Gas  ";
    str[1]="   Crude Oil   ";
    str[2]="     Coal      ";
    str[3]="    Methanol   ";
    str[4]=" Hydro & Geoth.";
    str[5]="     Wind      ";
    str[6]=" Photovoltaics ";

    str[7]="    Biomass    ";
    str[8]="    Nuclear    ";
    str[9]="  Innovatives  ";
    write_table(fp,&nc,cap,str,txm[ts_psup],10,N_TMP);
  }

  cap="Final Energy Consumption (MTOE/year)";
  str[0]="   Hydrogen    ";
  str[1]="  Natural Gas  ";
  str[2]="  Oil Products ";
  str[3]="    Methanol   ";

  str[4]="    Ethanol    ";
  str[5]="     Coal      ";
  str[6]="    Biomass    ";
  str[7]="  Electricity  ";
  str[8]="  Innovatives  ";
  write_table(fp,&nc,cap,str,txm[ts_sene],9,N_TMP);

  cap="CO2 Emissions (Mt-C/Year)";
  str[0]=" Gross Emission";
  str[1]="   Net Import  ";
  str[2]="  EOR Use Disp.";
  str[3]=" Gas Well Disp.";
  str[4]=" Aquifer  Disp.";
  str[5]="  Ocean   Disp.";
  str[6]=" Reforestation ";
  str[7]="  Net Emission ";
  str[8]=" Emission Right";
  write_table(fp,&nc,cap,str,txm[ta_eco2],9,N_TMP);


  cap="Sulphur Emissions (Mt-S/Year)";

  str[0]=" Gross Emission";

  str[1]=" Coal Cleaning ";

  str[2]=" Sorbent Coal  ";

  str[3]=" W.L.S. Coal   ";

  str[4]=" Wellman Coal  ";

  str[5]=" De-S IGCC etc.";

  str[6]=" De-S Coal Dem.";

  str[7]=" Sorbent on Oil";

  str[8]=" W.L.S. on Oil ";

  str[9]=" Wellman on Oil";

  str[10]=" De-S Refinary ";

  str[11]=" De-S Oil Dem. ";

  str[12]=" Net Emission  ";

  write_table(fp,&nc,cap,str,txm[ts_ene[8]],13,N_TMP);


  cap="Hydrogen Balance (MTOE/Year)";
  if(n!=LR) 
    str[0]="   Net Import  ";
  else
    str[0]=" Transport Loss";
  str[1]="    IES Prod.  ";
  str[2]=" Electrolysis  "; 
  str[3]="   Ele. Gene.  ";
  str[4]="    IES Cons.  ";
  str[5]="  Final Demand ";
  str[6]=" Distrib. Loss ";
  write_table(fp,&nc,cap,str,txm[ts_ene[0]],7,N_TMP);

  cap="Natural Gas Balance (MTOE/Year)";
  if(n!=LR) 
    str[0]="   Net Import  ";
  else
    str[0]=" Transport Loss";
  str[1]=" Indogen. Prod.";
  str[2]="    IES Prod.  "; 
  str[3]="  Coal Liquif. ";
  str[4]="   Ele. Gene.  ";
  str[5]="    Splitting  ";
  str[6]="  Final Demand ";
  str[7]="  Feed Stocks  ";
  str[8]=" Distrib. Loss ";
  write_table(fp,&nc,cap,str,txm[ts_ene[1]],9,N_TMP);

  cap="Oil Balance (MTOE/Year)";
  if(n!=LR) 
    str[0]="   Net Import  ";
  else
    str[0]=" Transport Loss";
  str[1]=" Indogen. Prod.";
  str[2]="    EOR Prod.  "; 
  str[3]="  Coal Liquif. ";
  str[4]="  Bio. Liquif. ";
  str[5]="   Ele. Gene.  ";
  str[6]="    Gasoline   ";
  str[7]="   Light Fuel  ";
  str[8]="   Heavy Fuel  ";
  str[9]="  Feed Stocks  ";
  str[10]=" Refinery Loss ";
  str[11]=" Distrib. Loss ";

  write_table(fp,&nc,cap,str,txm[ts_ene[2]],12,N_TMP);

  cap="Coal Balance (MTOE/Year)";
  if(n!=LR) 
    str[0]="   Net Import  ";
  else
    str[0]=" Transport Loss";
  str[1]=" Indogen. Prod.";
  str[2]=" Ele. Ge.      ";
  str[3]=" Ele. Ge.IGCC  ";
  str[4]="    IES Cons.  ";
  str[5]="   Coal Liquf. ";
  str[6]="  Final Demand ";
  str[7]="  Feed Stocks  ";
  str[8]=" Distrib. Loss ";
  write_table(fp,&nc,cap,str,txm[ts_ene[3]],9,N_TMP);

  cap="Biomass Balance (MTOE/Year)";
  str[0]=" Energy Crops  ";
  str[1]="Modern FuelWood";
  str[2]=" Wood Residues ";
  str[3]="Sawmill Residue";

  str[4]=" Timber Scraps ";

  str[5]=" Cereal Harvest";

  str[6]="Sugarcase Harv.";

  str[7]="  Bagasse      ";

  str[8]=" Paper Scraps  ";

  str[9]=" Black Liquor  ";

  str[10]=" Kitchen Wastes";

  str[11]="Animal Waste(D)";

  str[12]="Animal Waste(W)";

  str[13]=" Human Feces   ";

  str[14]=" Ele. Ge.      ";

  str[15]=" Gasification  ";

  str[16]=" Liquefaction  ";

  str[17]="    End Use    ";
  str[18]=" Distrib. Loss ";
  write_table(fp,&nc,cap,str,txm[ts_ene[4]],19,N_TMP);

  cap="Methanol Balance (MTOE/Year)";
  if(n!=LR) 
    str[0]="   Net Import  ";
  else
    str[0]=" Transport Loss";
  str[1]=" MeOH Syn.(CO) ";
  str[2]=" MeOH Syn.(CO2)";
  str[3]="   Elec. Gene. ";
  str[4]="    Gasoline   ";
  str[5]="   Light Fuel  ";
  str[6]="   Heavy Fuel  ";
  str[7]=" Distrib. Loss ";
  write_table(fp,&nc,cap,str,txm[ts_ene[5]],8,N_TMP);

  cap="Wind Power Balance (TWh/Year)";
  str[0]=" Indogen. Prod.";
  str[1]="  Elec. Grids  ";
  str[2]="  Electrolysis ";
  write_table(fp,&nc,cap,str,txm[ts_ene[6]],3,N_TMP);

  if(n<LR) {
    cap="Shares of Heavy Oil (%)";
    str[0]="     Share     ";
    write_table(fp,&nc,cap,str,txm[ts_ene[7]],1,N_TMP);
  }


  cap="Major Biomass Balances (MTOE/Year)";

  str[0]="  Fuel Wood 1  ";

  str[1]="  Fuel Wood 2  ";

  str[2]="  Fuel Wood 3  ";

  str[3]="  Fuel Wood 4  ";

  str[4]="  Fuel Wood 5  ";

  str[5]=" Wood Residues ";

  str[6]="Sawmill Residue";

  str[7]="Timber Scrap(L)";

  str[8]="Timber Scrap(M)";

  str[9]="Timber Scrap(H)";

  str[10]=" Cereal Harvest";

  str[11]="Sugarcase Harv.";

  str[12]="  Bagasse      ";

  str[13]=" Energy Crops  ";

  str[14]=" Gasification  ";

  str[15]=" Liquefaction  ";

  str[16]="    End Use    ";

  str[17]=" Ele. Ge.      ";

  write_table(fp,&nc,cap,str,txm[ts_bio[0]],18,N_TMP);



  cap="Energy Crops Balances (MTOE/Year)";

  str[0]=" Energy Crops 1";

  str[1]=" Energy Crops 2";

  str[2]=" Energy Crops 3";

  str[3]=" Energy Crops 4";

  str[4]=" Energy Crops 5";

  str[5]=" EOH Gasoline  ";

  str[6]=" EOH Light Fuel";

  str[7]=" EOH Heavy Fuel";

  str[8]=" Non EOH Use   ";

  write_table(fp,&nc,cap,str,txm[ts_bio[1]],9,N_TMP);



  cap="Paper Scraps Balances (MTOE/Year)";

  str[0]="   Supplies    ";

  str[1]="  Final Demand ";

  str[2]=" Gasification  ";

  str[3]=" Ele. Ge.      ";

  write_table(fp,&nc,cap,str,txm[ts_bio[2]],4,N_TMP);



  cap="Biomass Balances for Electric Fuel (MTOE/Year)";

  str[0]=" Black Liquor  ";

  str[1]=" Kitchen Wastes";

  str[2]="Animal Waste(D)";

  str[3]=" Paper scraps  ";

  str[4]=" Major Biomass ";

  str[5]=" Ele. Ge.      ";

  write_table(fp,&nc,cap,str,txm[ts_bio[3]],6,N_TMP);



  cap="Arable Land Use (Mha)";

  str[0]=" Energy Crops  ";

  str[1]="   Fuel Wood   ";

  str[2]=" Arable land   ";

  write_table(fp,&nc,cap,str,txm[ts_bio[4]],3,N_TMP);



  cap="Energy Crops Production (Mha)";

  str[0]=" Energy Crops 1";

  str[1]=" Energy Crops 2";

  str[2]=" Energy Crops 3";

  str[3]=" Energy Crops 4";

  str[4]=" Energy Crops 5";

  str[5]="Total Prodction";

  str[6]="    Potential  ";

  write_table(fp,&nc,cap,str,txm[ts_bio[5]],7,N_TMP);



  cap="Modern Fuel Woods Production (Mha)";

  str[0]="  Fuel Wood 1  ";

  str[1]="  Fuel Wood 2  ";

  str[2]="  Fuel Wood 3  ";

  str[3]="  Fuel Wood 4  ";

  str[4]="  Fuel Wood 5  ";

  str[5]="Total Prodction";

  str[6]="    Potential  ";

  write_table(fp,&nc,cap,str,txm[ts_bio[6]],7,N_TMP);




  cap="Hydrogen Balances in IES (MTOE/Year)";
  str[0]=" From Shift R. "; 
  str[1]=" External Input";
  str[2]=" Ngas Splitting";
  str[3]=" Coal Gasific. ";
  str[4]=" Bio. Gasific. ";
  str[5]=" Methane  Prod.";
  str[6]=" MeOH Syn.(CO) ";
  str[7]=" MeOH Syn.(CO2)";
  str[8]="  TO  Shift R. ";
  str[9]="     Output    ";
  write_table(fp,&nc,cap,str,txm[ts_ies[0]],10,N_TMP);

  cap="Carbon Monoxide Balances in IES (MTOE/Year)";
  str[0]=" From Shift R. "; 
  str[1]=" Ngas Splitting";
  str[2]=" Coal Gasific. ";
  str[3]=" Bio. Gasific. ";
  str[4]=" Methane  Prod.";
  str[5]=" MeOH Syn.(CO) ";
  str[6]="  TO  Shift R. ";
  write_table(fp,&nc,cap,str,txm[ts_ies[1]],7,N_TMP);

  cap="Carbon Dioxide Balances in IES (Mt-C/Year)";
  str[0]=" From Shift R. "; 
  str[1]=" External Input";
  str[2]=" Ngas Splitting";
  str[3]=" Coal Gasific. ";
  str[4]=" Bio. Gasific. ";
  str[5]="  TO  Shift R. ";
  str[6]=" Physical Rec. ";
  str[7]=" MeOH Syn.(CO2)";
  write_table(fp,&nc,cap,str,txm[ts_ies[2]],8,N_TMP);

  cap="Recovered Carbon Dioxide Balances in IES (Mt-C/Year)";
  if(n!=LR) 
    str[0]="   Net Import  ";
  else
    str[0]=" Transport Loss";
  str[1]=" Physical Rec. ";
  str[2]="   From IGCC  P";
  str[3]="   From IGCC  M";
  str[4]="   From IGCC  B";
  str[5]=" Chemical Rec.P";
  str[6]=" Chemical Rec.M";
  str[7]=" Chemical Rec.B";
  str[8]=" Recycle in IES";
  str[9]="  EOR Use Disp.";
  str[10]=" Gas Well Disp.";
  str[11]=" Aquifer  Disp.";
  str[12]="  Ocean   Disp.";
  write_table(fp,&nc,cap,str,txm[ts_rco2],13,N_TMP);

  cap="Gaseous Fuel Balances (MTOE/Year)";
  str[0]="   Hydrogen    ";
  str[1]="  Natural Gas  ";
  str[2]="Animal Waste(W)";
  str[3]=" Human Feces   ";
  str[4]="  Innovatives  ";
  str[5]="  Conservation ";
  str[6]="  Final Demand ";
  write_table(fp,&nc,cap,str,txm[td_ndemd[0]],7,N_TMP);

  cap="Gasoline Fuel Balances (MTOE/Year)";
  str[0]="   Petroleum   ";
  str[1]="   Ethanol     ";
  str[2]="   Methanol    ";
  str[3]="  Innovatives  ";
  str[4]="  Conservation ";
  str[5]="  Final Demand ";
  write_table(fp,&nc,cap,str,txm[td_ndemd[1]],6,N_TMP);

  cap="Light Liquid Fuel Balances (MTOE/Year)";
  str[0]="   Petroleum   ";
  str[1]="   Ethanol     ";

  str[2]="   Methanol    ";

  str[3]="  Innovatives  ";

  str[4]="  Conservation ";

  str[5]="  Final Demand ";
  write_table(fp,&nc,cap,str,txm[td_ndemd[2]],6,N_TMP);

  cap="Heavy Liquid Fuel Balances (MTOE/Year)";
  str[0]="   Petroleum   ";
  str[1]="   Ethanol     ";

  str[2]="   Methanol    ";

  str[3]="  Innovatives  ";

  str[4]="  Conservation ";

  str[5]="  Final Demand ";
  write_table(fp,&nc,cap,str,txm[td_ndemd[3]],6,N_TMP);

  cap="Solid Fuel Balances (MTOE/Year)";
  str[0]="     Coal      ";
  str[1]="Bio.(Exc.paper)";

  str[2]="  Paper scraps ";
  str[3]="  Innovatives  ";
  str[4]="  Conservation ";
  str[5]="  Final Demand ";
  write_table(fp,&nc,cap,str,txm[td_ndemd[4]],6,N_TMP);

  cap="Electricity Balances in Peak (TWh/Year)";
  str[0]="   H2 Fueled   "; 
  str[1]="  Ngas Fired   ";
  str[2]="   Oil Fired   ";
  str[3]="  Coal Fired   ";
  str[4]=" IGCC CO2 Rec. ";
  str[5]="  Biomass Fired";
  str[6]=" Methanol Fired";
  str[7]="    Nuclear    ";
  str[8]="  Ele. Storage ";
  str[9]="  Hydro&Geoth. ";
  str[10]="     Wind      ";
  str[11]=" Photovoltaics ";
  str[12]="  Total Supply ";
  str[13]=" For Transport ";
  str[14]=" For CO2 Rec.Ch";
  str[15]=" For CO2 Rec.Ph";
  str[16]=" For CO2 Dispo.";
  str[17]="  Electrolysis ";
  str[18]="  N Gas Split  ";
  str[19]="  Coal Gasific.";
  str[20]="  Bio. Gasific.";
  str[21]=" MeOH Syn.(CO) ";
  str[22]=" MeOH Syn.(CO2)";
  str[23]=" Distrib. Loss ";
  str[24]="  Innovatives  ";
  str[25]="  Conservation ";
  str[26]="  Final Demand ";
  write_table(fp,&nc,cap,str,txm[td_edemd[0]],27,N_TMP);

  cap="Electricity Balances in Intermediate (TWh/Year)";
  write_table(fp,&nc,cap,str,txm[td_edemd[1]],27,N_TMP);

  cap="Electricity Balances in Off-peak (TWh/Year)";
  write_table(fp,&nc,cap,str,txm[td_edemd[2]],27,N_TMP);

  cap="Electricity Balances for the whole periods (TWh/Year)";
  write_table(fp,&nc,cap,str,txm[td_edemd[3]],27,N_TMP);

  cap="Instantaneous Peak Supply (GW)";

  str[14]=" For CO2 Dispo.";
  str[15]=" For CO2 Rec.Ph";
  str[16]="  N Gas Split  ";
  str[17]="  Coal Gasific.";
  str[18]="  Bio. Gasific.";
  str[19]=" MeOH Syn.(CO) ";
  str[20]=" MeOH Syn.(CO2)";
  str[21]="  Final Demand ";
  write_table(fp,&nc,cap,str,txm[td_edemd[4]],22,N_TMP);

  if(n<LR) {
    cap="Regional Average Thermal Efficiency of Power Plants (%)";
    str[0]="  Efficiency    ";
    write_table(fp,&nc,cap,str,txm[td_edemd[5]],1,N_TMP);
  }

  cap="Hydorgen Fueled Power Plant (GW)";
  str[0]="  Current stage";
  str[1]="(-1) time stage";
  str[2]="(-2) time stage";
  str[3]="  Required Cap.";
  write_table(fp,&nc,cap,str,txm[tp_elec[0]],4,N_TMP);

  cap="Natural Gas Fired Power Plant (GW)";
  write_table(fp,&nc,cap,str,txm[tp_elec[1]],4,N_TMP);

  cap="Oil Fired Power Plant (GW)";
  write_table(fp,&nc,cap,str,txm[tp_elec[2]],4,N_TMP);

  cap="Coal Fired Power Plant (GW)";
  write_table(fp,&nc,cap,str,txm[tp_elec[3]],4,N_TMP);

  cap="IGCC Fired Power Plant (GW)";
  write_table(fp,&nc,cap,str,txm[tp_elec[4]],4,N_TMP);

  cap="Biomass Fired Power Plant (GW)";
  write_table(fp,&nc,cap,str,txm[tp_elec[5]],4,N_TMP);

  cap="Methanol Fired Power Plant (GW)";
  write_table(fp,&nc,cap,str,txm[tp_elec[6]],4,N_TMP);

  cap="Nuclear Power Plant (GW)";
  write_table(fp,&nc,cap,str,txm[tp_elec[7]],4,N_TMP);

  cap="Electricity Storage Fired Power Plant (GW)";
  write_table(fp,&nc,cap,str,txm[tp_elec[8]],4,N_TMP);

  cap="Oil Refinery Plant (Distillation) (MTOE/year)";
  write_table(fp,&nc,cap,str,txm[tp_chem[0]],4,N_TMP);

  cap="Oil Refinery Plant (Gasoline) (MTOE/year)";
  write_table(fp,&nc,cap,str,txm[tp_chem[1]],4,N_TMP);

  cap="Natural Gas Splitting Plant (MTOE/year)";
  write_table(fp,&nc,cap,str,txm[tp_chem[2]],4,N_TMP);

  cap="Coal Gasification Plant (MTOE/year)";
  write_table(fp,&nc,cap,str,txm[tp_chem[3]],4,N_TMP);

  cap="Coal Liquifaction Plant (MTOE/year)";
  write_table(fp,&nc,cap,str,txm[tp_chem[4]],4,N_TMP);

  cap="Biomass Gasification Plant(Pyrolysis) (MTOE/year)";
  write_table(fp,&nc,cap,str,txm[tp_chem[5]],4,N_TMP);

  cap="Biomass Liquifaction Plant(Synthesis) (MTOE/year)";
  write_table(fp,&nc,cap,str,txm[tp_chem[6]],4,N_TMP);

  cap="Methane Synthesis Plant (MTOE/year)";
  write_table(fp,&nc,cap,str,txm[tp_chem[7]],4,N_TMP);

  cap="Methanol Syn. from CO  Plant (MTOE/year)";
  write_table(fp,&nc,cap,str,txm[tp_chem[8]],4,N_TMP);

  cap="Methanol Syn. from CO2  Plant (MTOE/year)";
  write_table(fp,&nc,cap,str,txm[tp_chem[9]],4,N_TMP);

  cap="Shift Conversion Plant (MTOE/year)";
  write_table(fp,&nc,cap,str,txm[tp_chem[10]],4,N_TMP);

  cap="Methanol Up-grading Plant (MTOE/year)";
  write_table(fp,&nc,cap,str,txm[tp_chem[11]],4,N_TMP);

  cap="Water Electrolysis Plant for Peak (MTOE/year)";
  write_table(fp,&nc,cap,str,txm[tp_chem[12]],4,N_TMP);
  cap="Water Electrolysis Plant for Intermediate (MTOE/year)";
  write_table(fp,&nc,cap,str,txm[tp_chem[13]],4,N_TMP);
  cap="Water Electrolysis Plant for Off-peak (MTOE/year)";
  write_table(fp,&nc,cap,str,txm[tp_chem[14]],4,N_TMP);

  cap="CO2 Chemical Recovery Plant (Mt-C/year)";
  write_table(fp,&nc,cap,str,txm[tp_chem[15]],4,N_TMP);

  cap="CO2 Physical Recovery Plant (Mt-C/year)";
  write_table(fp,&nc,cap,str,txm[tp_chem[16]],4,N_TMP);



  cap="Biomass Gasification (Anaerobic Digestion) (MTOE/year)";

  write_table(fp,&nc,cap,str,txm[tp_chem[17]],4,N_TMP);



  cap="Biomass Liquefaction (Fermentation) (MTOE/year)";

  write_table(fp,&nc,cap,str,txm[tp_chem[18]],4,N_TMP);



  if(n<=LR) {
    cap="Cumulative Production of Natural Gas";
    str[0]="  Grade 1 (%)  ";
    str[1]="  Grade 2 (%)  ";
    str[2]="  Grade 3 (%)  ";
    str[3]="  Grade 4 (%)  ";
    str[4]="  Grade 5 (%)  ";
    str[5]="  Grade 6 (%)  ";
    str[6]="  Grade 7 (%)  ";
    str[7]="  Grade 8 (%)  ";
    str[8]="  Total (GTOE) ";
    write_table(fp,&nc,cap,str,txm[ts_exha[0]],9,N_TMP);

    cap="Cumulative Production of Oil";
    write_table(fp,&nc,cap,str,txm[ts_exha[1]],9,N_TMP);

    cap="Cumulative Production of Coal";
    write_table(fp,&nc,cap,str,txm[ts_exha[2]],9,N_TMP);
  }

  cap="Cumulative CO2 Disposal,Absorption and Net Emissions (Gt-C)";
  str[0]=" EOR Use(Low)  ";
  str[1]=" EOR Use(High) ";
  str[2]="    Gas Well   ";
  str[3]="Aquifer(Grade1)";
  str[4]="Aquifer(Grade2)";
  str[5]="Aquifer(Grade3)";
  str[6]="Aquifer(Grade4)";
  str[7]="Aquifer(Grade5)";
  str[8]="    Ocean      ";
  str[9]="Reforest(Low)  ";
  str[10]="Reforest(Mid)  ";
  str[11]="Reforest(High) ";
  str[12]=" Net Emissions ";
  write_table(fp,&nc,cap,str,txm[ts_dco2],13,N_TMP);


  cap="Costs for Inter-regional Transportation (Billion dollars/year)";
  str[0]="   Hydrogen    ";
  str[1]="  Natural Gas  ";
  str[2]="      CO2      ";
  str[3]="      Oil      ";
  str[4]="     Coal      ";
  str[5]="    Methanol   ";
  str[6]="     Total     ";
  write_table(fp,&nc,cap,str,txm[tc_cost[0]],7,N_TMP);

  cap="Inter-regional Trade Accounts (Billion dollars/year)";
  str[0]="   Hydrogen    ";
  str[1]="  Natural Gas  ";
  str[2]="      CO2      ";
  str[3]="      Oil      ";
  str[4]="     Coal      ";
  str[5]="    Methanol   ";
  str[6]="     Total     ";
  write_table(fp,&nc,cap,str,txm[tc_cost[1]],7,N_TMP);

  cap="Export Profits Due to Additional Fees (Billion dollars/year)";
  str[0]="   Hydrogen    ";
  str[1]="  Natural Gas  ";
  str[2]="      Oil      ";
  str[3]="     Coal      ";
  str[4]="    Methanol   ";
  str[5]="     Total     ";
  write_table(fp,&nc,cap,str,txm[tc_cost[2]],6,N_TMP);

  cap="Import Tariffs (Billion dollars/year)";
  str[0]="   Hydrogen    ";
  str[1]="  Natural Gas  ";
  str[2]="      Oil      ";
  str[3]="     Coal      ";
  str[4]="    Methanol   ";
  str[5]="     Total     ";
  write_table(fp,&nc,cap,str,txm[tc_cost[3]],6,N_TMP);

  cap="Emissions Right Trades (Billion dollars/year)";
  str[0]=" Net Purchased1";

  str[1]="  Trans. Cost 1";

  str[2]=" Net Purchased2";
  str[3]="  Trans. Cost 2";
  str[4]="     Total     ";
  write_table(fp,&nc,cap,str,txm[tc_cost[4]],5,N_TMP);

  cap="Fossil Fuel Production Costs (Billion dollars/year)";
  str[0]="  Natural Gas  ";
  str[1]="   Crude Oil   ";
  str[2]="     Coal      ";
  str[3]="     Total     ";
  write_table(fp,&nc,cap,str,txm[tc_cost[5]],4,N_TMP);

  cap="Royalties for Fossil Fuel Production (Billion dollars/year)";
  str[0]="  Natural Gas  ";
  str[1]="   Crude Oil   ";
  str[2]="     Coal      ";
  str[3]="     Total     ";
  write_table(fp,&nc,cap,str,txm[tc_cost[6]],4,N_TMP);

  cap="Non-Fossil Fuel Production Costs (Billion dollars/year)";

  str[0]=" Hydro & Geoth.";
  str[1]="     Wind      ";
  str[2]=" Photovoltaics ";

  str[3]="    Biomass    ";
  str[4]="   Nuclear*    ";
  str[5]="     Total     ";
  write_table(fp,&nc,cap,str,txm[tc_cost[7]],6,N_TMP);
  fprintf(fp,"----------------------------\n");
  fprintf(fp," *) Only variable cost\n");

  cap="Subsidies for Energy Production (Billion dollars/year)";
  str[0]="  Natural Gas  ";
  str[1]="   Crude Oil   ";
  str[2]="     Coal      ";
  str[3]=" Hydro & Geoth.";
  str[4]="     Wind      ";
  str[5]=" Photovoltaics ";

  str[6]="    Biomass    ";
  str[7]="     Total     ";
  write_table(fp,&nc,cap,str,txm[tc_cost[8]],8,N_TMP);

  cap="Plant Construction Costs (Billion dollars/year)";
  str[0]="H2 fueled power";
  str[1]="  N.G.  power  ";
  str[2]="  Oil   power  ";
  str[3]="  Coal  power  ";
  str[4]=" IGCC  CO2 Rec.";
  str[5]="  Bio.  power  ";
  str[6]="  MeOH  power  ";
  str[7]=" Nuclear power ";
  str[8]=" Elec. storage ";
  str[9]="Oil refi. disti";
  str[10]="Oil refi. gasol";
  str[11]=" N.G. splitting";
  str[12]="Coal gasificat.";
  str[13]="Coal liquefact.";
  str[14]="Bio. gasificat.";
  str[15]="Bio. liquefact.";
  str[16]="Methane synth. ";
  str[17]="MeOH synth. CO ";

  str[18]="MeOH synth. CO2";
  str[19]="Shift converter";
  str[20]=" Mobile method ";
  str[21]="  Electrolysis ";
  str[22]=" CO2 recov.(Ch)";
  str[23]=" CO2 recov.(Ph)";

  str[24]="Bio.Anaero Gas ";

  str[25]="Bio.Fermen Liq.";
  str[26]="     Total     ";
  write_table(fp,&nc,cap,str,txm[tc_cost[9]],27,N_TMP);

  cap="CO2 Disposal Costs (Billion dollars/year)";
  str[0]="    EOR Use    ";
  str[1]="    Gas Well   ";
  str[2]="    Aquifer    ";
  str[3]="    Ocean      ";
  str[4]="     Total     ";
  write_table(fp,&nc,cap,str,txm[tc_cost[10]],5,N_TMP);


  cap="Desulphur Costs (Billion dollars/year)";
  str[0]=" Coal Cleaning ";
  str[1]=" Oil Refinery  ";
  str[2]=" Sorbent Injec.";
  str[3]="     W.L.S     ";
  str[4]=" Wellman-Lord  ";
  str[5]=" DeS on F.Dem. ";
  str[6]="     Total     ";
  write_table(fp,&nc,cap,str,txm[tc_cost[17]],7,N_TMP);


  if(ictrl8==0) {
    cap="Energy Conservation Costs (Billion dollars/year)";
    str[0]=" Gaseous Fuel  ";
    str[1]="  Liquid Fuel  ";
    str[2]="  Solid  Fuel  ";
    str[3]=" Electricity   ";
    str[4]="     Total     ";
    write_table(fp,&nc,cap,str,txm[tc_cost[11]],5,N_TMP);
  }
  else {
    cap="Macro Economic Indicators (Billion dollars/year)";
    str[0]=" Capital Stock ";
    str[1]=" Capital Invst.";
    str[2]="      GDP      ";
    str[3]=" Ref.Cap Stock ";
    str[4]=" Ref.Cap Invst.";
    str[5]=" Ref.  GDP     ";
    str[6]="     Total     ";
    write_table(fp,&nc,cap,str,txm[tc_cost[11]],7,N_TMP);
  }

  cap="Changes in Energy Distribution Costs (Billion dollars/year)";
  str[0]=" Gaseous Fuel  ";
  str[1]="  Liquid Fuel  ";
  str[2]="  Solid  Fuel  ";
  str[3]=" Electricity   ";
  str[4]="     Total     ";
  write_table(fp,&nc,cap,str,txm[tc_cost[12]],5,N_TMP);

  cap="Cost Structure of the Energy System (Billion dollars/year)";
  str[0]="    Trades     ";
  str[1]=" Emission Right";
  str[2]="  Fossil Fuel  ";
  str[3]="Non-Fossil Fuel";
  str[4]=" Plant Constrc.";
  str[5]="  CO2 Disposal ";
  str[6]="   Desulphur   ";

  if(ictrl8==0) 
    str[7]=" Energy Saving ";
  else 
    str[7]=" Macro Economy ";
  str[8]=" Reforestation ";
  str[9]="   Carbon Tax  ";
  str[10]="  Sulphur Tax  ";

  str[11]="  Innovatives  ";
  str[12]="     Total     ";
  str[13]="    Damges     ";
  str[14]=" Reference  GDP";
  write_table(fp,&nc,cap,str,txm[tc_cost[13]],15,N_TMP);

  cap="Discounted Sum of the Costs (Billion dollars in 2000)";
  write_table1(fp,&nc,cap,str,txm[tc_cost[14]],15);

  if(n<LR) {
    cap="Shadow Prices of Energy(CO2)Supplied ($/TOE)or($/t-C)";
    str[0]="   Hydrogen    ";
    str[1]="  Natural Gas  ";

	str[2]=" Recoverd CO2  "; 
    str[3]="  Oil Products ";
    str[4]="     Coal      ";

	str[5]="    Methanol   ";

	str[6]="      CO2      ";

	str[7]="    Biomass    ";
    write_table(fp,&nc,cap,str,txm[tc_price[0]],8,N_TMP);

    cap="Marginal Costs of Renewable Energy Sources ($/MWh)";
    str[0]=" Hydro & Geoth.";
    str[1]="     Wind      ";
    str[2]=" Photovoltaics ";

    str[3]=" Energy Crops 1";

    str[4]=" Energy Crops 2";

    str[5]=" Energy Crops 3";

    str[6]=" Energy Crops 4";

    str[7]=" Energy Crops 5";

	str[8]="  Fuel  Wood  1";

	str[9]="  Fuel  Wood  2";

	str[10]="  Fuel  Wood  3";

	str[11]="  Fuel  Wood  4";

	str[12]="  Fuel  Wood  5";

	str[13]=" Wood Residues ";

	str[14]="Sawmill Residue";

	str[15]="TimberScraps(L)";

	str[16]="TimberScraps(M)";

	str[17]="TimberScraps(H)";

	str[18]=" Cereal Harvest";

	str[19]="Sugarcase Harv.";

	str[20]="  Bagasse      ";

	str[21]=" Paper Scraps  ";

	str[22]=" Black Liquor  ";

	str[23]=" Kitchen Wastes";

	str[24]="Animal Waste(D)";

	str[25]="Animal Waste(W)";

	str[26]=" Human Feces   ";
    write_table(fp,&nc,cap,str,txm[tc_price[1]],27,N_TMP);

    cap="Imported Prices CIF ($/TOE) or ($/t-C)";
    str[0]="   Hydrogen    ";
    str[1]="  Natural Gas  ";
    str[2]="      CO2      ";
    str[3]="      Oil      ";
    str[4]="     Coal      ";
    str[5]="    Methanol   ";
    str[6]="Emission Right1";
    str[7]="Emission Right2";

    str[8]="Synthesized Oil";

    write_table(fp,&nc,cap,str,txm[tc_price[2]],9,N_TMP);

    cap="Energy Prices in End-Use Sectors ($/TOE) or ($/MWh)";
    str[0]=" Gaseous Fuel  ";
    str[1]="  Liquid Fuel  ";
    str[2]="  Solid  Fuel  ";
    str[3]=" Electricity   ";
    write_table(fp,&nc,cap,str,txm[tc_price[3]],4,N_TMP);

    cap="Energy Prices in End-Use Sectors  (Index:100 for prices in 2000)";
    str[0]=" Gaseous Fuel  ";
    str[1]="  Liquid Fuel  ";
    str[2]="  Solid  Fuel  ";
    str[3]=" Electricity   ";
    write_table(fp,&nc,cap,str,txm[tc_price[4]],4,N_TMP);

    cap="Marginal Costs in Electric Power Sector";
    str[0]=" Peak   ($/MWh)";
    str[1]=" Interm.($/MWh)";
    str[2]=" OffPeak($/MWh)";
    str[3]="Inst.Peak($/kW)";
    write_table(fp,&nc,cap,str,txm[tc_price[5]],4,N_TMP);

    cap="Shadow Prices of Carbon ($/t-C)";
    str[0]=" Shadow Price  ";
    write_table(fp,&nc,cap,str,txm[tc_price[6]],1,N_TMP);

    cap="Shadow Prices of Sulphur ($/t-S)";

    str[0]=" Shadow Price  ";

    write_table(fp,&nc,cap,str,txm[tc_price[7]],1,N_TMP);



  }
  else if(n==LR) {
    str[0]=" North America ";
    str[1]=" Western Europe";
    str[2]="     Japan     ";
    str[3]="    Oceania    ";
    str[4]="  C.P.E. Asia  ";
    str[5]="South&East.Asia";
    str[6]="M.East&N.Africa";
    str[7]="S.Sah.&S.Africa";
    str[8]=" Latin America ";
    str[9]=" FUSSR&E.Europe";

    cap="Total Energy System Costs (Billion dollars/year)";
    write_table(fp,&nc,cap,str,txm[tc_cost[15]],LR,N_TMP);

    cap="Total Discounted Sum of Energy System Costs (Billion dollars)";
    write_table1(fp,&nc,cap,str,txm[tc_cost[16]],LR);

    cap="H2 Trade Balances :Net Imports (MTOE/year)";
    write_table(fp,&nc,cap,str,txm[ts_trade[0]],LR,N_TMP);

    cap="Natural Gas Trade Balances :Net Imports (MTOE/year)";
    write_table(fp,&nc,cap,str,txm[ts_trade[1]],LR,N_TMP);

    cap="Oil Trade Balances :Net Imports (MTOE/year)";
    write_table(fp,&nc,cap,str,txm[ts_trade[2]],LR,N_TMP);

    cap="Coal Trade Balances :Net Imports (MTOE/year)";
    write_table(fp,&nc,cap,str,txm[ts_trade[3]],LR,N_TMP);

    cap="Methanol Trade Balances :Net Imports (MTOE/year)";
    write_table(fp,&nc,cap,str,txm[ts_trade[4]],LR,N_TMP);

    cap="CO2 Trade Balances :Net Imports (t-C/year)";
    write_table(fp,&nc,cap,str,txm[ts_trade[5]],LR,N_TMP);
 
    cap="Emission Right Trade Balances :Net Imports (t-C/year)";
    write_table(fp,&nc,cap,str,txm[ts_trade[6]],LR,N_TMP);

    cap="Natural Gas Production by Region (MTOE/year)";
    write_table(fp,&nc,cap,str,txm[ts_wep[0]],LR,N_TMP);

    cap="Oil Production by Region (MTOE/year)";
    write_table(fp,&nc,cap,str,txm[ts_wep[1]],LR,N_TMP);

    cap="Coal Production by Region (MTOE/year)";
    write_table(fp,&nc,cap,str,txm[ts_wep[2]],LR,N_TMP);

    cap="Hydro & Geothermal Generation by Region (MTOE/year)";
    write_table(fp,&nc,cap,str,txm[ts_wep[3]],LR,N_TMP);

    cap="Wind Power Generation by Region (MTOE/year)";
    write_table(fp,&nc,cap,str,txm[ts_wep[4]],LR,N_TMP);

    cap="Solar Power Generation by Region (MTOE/year)";
    write_table(fp,&nc,cap,str,txm[ts_wep[5]],LR,N_TMP);


    cap="Biomass Production by Region (MTOE/year)";

    write_table(fp,&nc,cap,str,txm[ts_wep[6]],LR,N_TMP);
 

	cap="Nuclear Power Generation by Region (MTOE/year)";
    write_table(fp,&nc,cap,str,txm[ts_wep[7]],LR,N_TMP);

/* CO2 Disposal */

    cap="CO2 for EOR Uses (Mt-C/year)";
    write_table(fp,&nc,cap,str,txm[ts_wco[0]],LR,N_TMP);

    cap="CO2 for Depleted Gas Well Injection (Mt-C/year)";
    write_table(fp,&nc,cap,str,txm[ts_wco[1]],LR,N_TMP);

    cap="CO2 for Aquifer Injection (Mt-C/year)";
    write_table(fp,&nc,cap,str,txm[ts_wco[2]],LR,N_TMP);

    cap="CO2 Ocean Disposal (Mt-C/year)";
    write_table(fp,&nc,cap,str,txm[ts_wco[3]],LR,N_TMP);

    cap="SOx Emissions (Mt-S/year)";
    write_table(fp,&nc,cap,str,txm[ts_wco[4]],LR,N_TMP);

  }

}

  void report_e()
{ int nc;
  char *cap,*str[30];
  FILE *fp;

  fp=fopen("earth.rep","w");

  nc=1;

  cap="Major GHG and SOX Emissions (unit for CO2: Gt-C/y, for SOx: Mt-S/y)";
  str[0]="CO2 Fossil     ";
  str[1]="CO2 Cement Prod";
  str[2]="CO2 Land Use   ";
  str[3]="Methane (Mt/y) ";
  str[4]="SOx Energy     ";
  str[5]="SOx non-Energy ";
  write_table2(fp,&nc,cap,str,emi_gas,6,N_TMP);

  cap="Major GHG Concentrations";
  str[0]="  CO2 (ppmv)   ";
  str[1]="  CH4 (ppbv)   ";
  str[2]="  N2O (ppbv)   ";
  write_table2(fp,&nc,cap,str,con_gas,3,N_TMP);

  cap="Radiative Forcing (W/m2, relative to those in 1990)";
  str[0]="  CO2          ";
  str[1]="  CH4          ";
  str[2]="  N2O          ";
  str[3]="  CFCs         ";
  str[4]="  Strat. O3    ";
  str[5]="  Tropo. O3    ";
  str[6]="  SOx Direct   ";
  str[7]="  SOx Indirect ";
  str[8]="  Bio Aerosol  ";
  str[9]="  Simple SUM   ";
  write_table2(fp,&nc,cap,str,del_q,10,N_TMP);
  
  cap="Temperature Changes (deg-C, relative to those in 1765)";
  str[0]=" North Land    ";
  str[1]=" North Ocean   ";
  str[2]=" North Average ";
  str[3]=" South Land    ";
  str[4]=" South Ocean   ";
  str[5]=" South Average ";
  str[6]=" Global Mean   ";
  write_table2(fp,&nc,cap,str,tmp_rise,7,N_TMP);

  cap="Sea Level Changes by Factor (cm, relative to those in 1990)";
  str[0]="Thermal Expans.";
  str[1]="Small Glaciers ";
  str[2]="Greenland Ice  ";
  str[3]="Antarctic Ice  ";
  str[4]="     Sum       ";
  write_table2(fp,&nc,cap,str,sea_rise,5,N_TMP);

  if(ictrl11==1) {
    cap="Regional Temp. Changes (deg-C, relative to those in 1765)";
    str[0]=" Region 1      ";
    str[1]=" Region 2      ";
    str[2]=" Region 3      ";
    str[3]=" Region 4      ";
    str[4]=" Region 5      ";
    str[5]=" Region 6      ";
    str[6]=" Region 7      ";
    str[7]=" Region 8      ";
    str[8]=" Region 9      ";
    str[9]=" Region 10     ";
    write_table2(fp,&nc,cap,str,rtmp_rise,10,N_TMP);

    cap="Regional Temp. Changes Approx. (deg-C, relative to those in 1765)";
    str[0]=" Region 1      ";
    str[1]=" Region 2      ";
    str[2]=" Region 3      ";
    str[3]=" Region 4      ";
    str[4]=" Region 5      ";
    str[5]=" Region 6      ";
    str[6]=" Region 7      ";
    str[7]=" Region 8      ";
    str[8]=" Region 9      ";
    str[9]=" Region 10     ";
    write_table2(fp,&nc,cap,str,rtmp_risex,10,N_TMP);
  }

  fclose(fp);
}

  void report_w(fp)
  FILE *fp;
{ /*int k,n,nc;
  static char *name[11]={" N.AMER"," W.EURO"," JAPAN "," AUS&NZ",
                         " CP.ASI"," SE.ASI"," ME&NAF"," SH&SAF",
                         " L.AMER"," FSU&EE"," TOTAL "};
*/
  fprintf(fp,"%s\n",lnz1);
  fprintf(fp,"%s\n",lnz1);
  fprintf(fp,"\n");
  fprintf(fp,"                          REPORT OF WORLD REGIONS\n");
  fprintf(fp,"\n");
  fprintf(fp,"%s\n",lnz1);
  fprintf(fp,"%s\n",lnz1);
  fprintf(fp,"\n");
/*  fprintf(fp," ABBREVIATION FOR THE NAMES OF WORLD REGIONS\n");
  fprintf(fp," N.AMER  : NORTH AMERICA\n");
  fprintf(fp," W.EURO  : WESTERN EUROPE\n");
  fprintf(fp,"  JAPAN  : JAPNA\n");
  fprintf(fp," AUS&NZ  : AUSTRALIA & NEW ZEALAND\n");
  fprintf(fp," CP.ASI  : CENTRALLY PLANNED ECONOMY ASIA\n");
  fprintf(fp," SE.ASI  : SOUTH & EAST ASIA\n");
  fprintf(fp," ME&NAF  : MIDDLE EAST & NORTHERN AFRICA\n");
  fprintf(fp," SH&SAF  : SUB-SAHARAN & SOUTHERN AFRICA\n");
  fprintf(fp," L.AMER  : LATIN AMERICA\n");
  fprintf(fp," FSU&EE  : FORMER SOVIET UNION & EASTERN EUROPE\n");
  fprintf(fp,"\n");
*/
}


  void write_table(fp,nc,cap,str,v,idim,jdim)
  FILE *fp;
  char *cap,**str;
  int *nc,idim,jdim;
  double **v;
{ int i,j,k;
  fprintf(fp,"%s\n",lnz1);
  fprintf(fp," Table.%2d     %s\n",(*nc)++,cap);
  fprintf(fp,"%s\n",lnz2);
  fprintf(fp,"%s\n",lnz3);
  for(k=0;k<N_SCE;k++) {
    fprintf(fp,"%s\n",lnz4);
    for(i=0;i<idim;i++) {
      fprintf(fp,"%15s",str[i]);
      for(j=0;j<jdim;j++)
        if(fabs(v[i][isce[k][j]])>=1.e8)
          fprintf(fp," -------");
        else if(fabs(v[i][isce[k][j]])>=10000.||v[i][isce[k][j]]==0.)
          fprintf(fp," %7.0f",v[i][isce[k][j]]);
        else if(fabs(v[i][isce[k][j]])>=10.)
          fprintf(fp," %7.1f",v[i][isce[k][j]]);
        else
          fprintf(fp," %7.3f",v[i][isce[k][j]]);
      fprintf(fp,"\n");
    }
  }
}


  void write_table1(fp,nc,cap,str,v,idim)
  FILE *fp;
  char *cap,**str;
  int *nc,idim;
  double **v;
{ int i,k;
  fprintf(fp,"%s\n",lnz1);
  fprintf(fp," Table.%2d     %s\n",(*nc)++,cap);
  for(k=0;k<N_SCE;k++) {
    fprintf(fp,"%s\n",lnz2);
    for(i=0;i<idim;i++) {
      fprintf(fp,"%15s",str[i]);
      if(fabs(v[i][k])>=1.e8)
        fprintf(fp," -------");
      else if(fabs(v[i][k])>=10000.||v[i][k]==0.)
        fprintf(fp," %7.0f",v[i][k]);
      else if(fabs(v[i][k])>=10.)
        fprintf(fp," %7.1f",v[i][k]);
      else
        fprintf(fp," %7.3f",v[i][k]);
      fprintf(fp,"\n");
    }
  }
}

  void write_table2(fp,nc,cap,str,v,idim,jdim)
  FILE *fp;
  char *cap,**str;
  int *nc,idim,jdim;
  double ***v;
{ int i,j,k;
  fprintf(fp,"%s\n",lnz1);
  fprintf(fp," Table.%2d     %s\n",(*nc)++,cap);
  fprintf(fp,"%s\n",lnz2);
  fprintf(fp,"%s\n",lnz3);
  for(k=0;k<N_SCE;k++) {
    fprintf(fp,"%s\n",lnz4);
    for(i=0;i<idim;i++) {
      fprintf(fp,"%15s",str[i]);
      for(j=0;j<jdim;j++)
        if(fabs(v[k][i][j])>=1.e8) fprintf(fp," -------");
        else if(fabs(v[k][i][j])>=10000.||v[k][i][j]==0.)
          fprintf(fp," %7.0f",v[k][i][j]);
        else if(fabs(v[k][i][j])>=10.)
          fprintf(fp," %7.1f",v[k][i][j]);
        else
          fprintf(fp," %7.3f",v[k][i][j]);
      fprintf(fp,"\n");
    }
  }
}


  void write_trade_mat(fp,nc,cap,str,v,idim,jdim)
  FILE *fp;
  char *cap,**str;
  int *nc,idim,jdim;
  double **v;
{ int i,j,k;
  fprintf(fp,"%s\n",lnz1);
  fprintf(fp," Table.%2d     %s\n",(*nc)++,cap);
  fprintf(fp,"%s\n",lnz2);
  fprintf(fp,"%s\n",lnz3);
  for(k=0;k<N_SCE;k++) {
    fprintf(fp,"%s\n",lnz4);
    for(i=0;i<idim;i++) {
      fprintf(fp,"%15s",str[i]);
      for(j=0;j<jdim;j++)
        if(fabs(v[i][isce[k][j]])>=1.e8)
          fprintf(fp," -------");
        else if(fabs(v[i][isce[k][j]])>=10000.||v[i][isce[k][j]]==0.)
          fprintf(fp," %7.0f",v[i][isce[k][j]]);
        else if(fabs(v[i][isce[k][j]])>=10.)
          fprintf(fp," %7.1f",v[i][isce[k][j]]);
        else
          fprintf(fp," %7.3f",v[i][isce[k][j]]);
      fprintf(fp,"\n");
    }
  }
}


  void title(fp,n)
  FILE *fp;
  int n;
{
  fprintf(fp,"%s\n",lnz1);
  fprintf(fp,"\n");
  fprintf(fp,
     "               *------------------------------------------------*\n");
  fprintf(fp,
     "               |                                                |\n");
  switch(n) {
        case 0: 
                fprintf(fp,
     "               |          REPORT OF NORTH AMERICA CASE          |\n");
                break;
        case 1:
                fprintf(fp,
     "               |          REPORT OF WESTERN EUROPE CASE         |\n");
                break;
        case 2:
                fprintf(fp,
     "               |               REPORT OF JAPAN CASE             |\n");
                break;
	case 3:
                fprintf(fp,
     "               |              REPORT OF OCEANIA CASE            |\n");
	        break;
        case 4: 
                fprintf(fp,
     "               | REPORT OF CENTRALLY PLANNED ECONOMY ASIA CASE  |\n");
                break;
        case 5:
                fprintf(fp,
     "               |         REPORT OF SOUTH & EAST ASIA CASE       |\n");
                break;
        case 6:
                fprintf(fp,
     "               |  REPORT OF MIDDLE EAST & NORTHERN AFRICA CASE  |\n");
                break;
	case 7:
                fprintf(fp,
     "               |   REPORT OF SUBSAHARAN & SOUTHERN AFRICA CASE  |\n");
	        break;
        case 8: 
                fprintf(fp,
     "               |          REPORT OF LATIN AMERICA CASE          |\n");
                break;
        case 9:
                fprintf(fp,
     "               |   REPORT OF FORMER USSR & EASTERN EUROPE CASE  |\n");
                break;
	case 10:
                fprintf(fp,
     "               |             REPORT OF WORLD REGIONS            |\n");
	        break;
	case 11:
                fprintf(fp,
     "               |             REPORT OF OECD REGIONS             |\n");
	        break;
	case 12:
                fprintf(fp,
     "               |           REPORT OF NON_OECD REGIONS           |\n");
	        break;
	case 13:
                fprintf(fp,
     "               |           REPORT OF ANNEX1 COUNTRIES           |\n");
	        break;
	case 14:
                fprintf(fp,
     "               |         REPORT OF NON_ANNEX1 COUNTRIES         |\n");
	        break;
	case 15:
                fprintf(fp,
     "               |             REPORT OF ASIAN REGIONS            |\n");
	        break;
       default:
                printf(" Too many regions!!\n"); exit(0);
                break;
  }
  fprintf(fp,
     "               |                                                |\n");
  fprintf(fp,
     "               *------------------------------------------------*\n");
  fprintf(fp,"\n");
  fprintf(fp,"%s\n",lnz1);
}

